"use strict";
this.name        = "hardmenu";
this.author      = "Norby";
this.copyright   = "2013 Norbert Nagy";
this.licence     = "CC BY-NC-SA 3.0";
this.description = "Hard Ships with armours and defensive equipments";

//customizable properties
this.$HardMenu_StartCredits = 100000; //Buy your first ship from this, the rest will be your starting money
this.$HardMenu_StartFuel = 0; //set to 7 if you want to start with full tank
this.$HardMenu_TestDriveTime = 20; //minutes

//internal properties, should not touch
this.$HardMenu_TestDriveTimer = null;
this.$HardMenu_TestDriveTimerEnd = null;
this.$HardMenu_TestDriveTimerEnd2 = null;
this.$HardMenu_Name = [ "hardcobra3-player",
	"hardcobramk1-player",
	"hardadder-player",
	"hardmoray-player",
	"hardanaconda-player",
	"hardasp-player",
	"hardboa-player",
	"hardboa2-player",
	"hardelance-player",
	"hardpython-player",
	"gecko-player",//90k
	"krait-player",//80k
	"mamba-player",//85k
	"sidewinder-player",//75k
	"shuttle-player",//guess:20k
	"transporter-player",//guess:40k
	"worm-player",//guess:30k
	"viper-player",//520k
	"viper-interceptor-player",//620k
	"constrictor-player",//10M
	"thargoid-player",//guess:10M
	"tharglet-player"];//guess:200k
this.$HardMenu_LastMainMenuItem = 0;
this.$HardMenu_serviceLevel = 95;

this.startUp = function() {
	if( worldScripts["start_choices"] ) delete worldScripts["start_choices"].guiScreenChanged;
}

this.guiScreenChanged = function(to, from) {
	if( missionVariables.oolite_tutorial ) return;
	//start in HardCobra v1.0 if press F1 before choose any ship
	if( !worldScripts["rocketmenu"] && ( from == "GUI_SCREEN_INTRO2" || from == "GUI_SCREEN_NEWGAME")
		&& to == "GUI_SCREEN_STATUS") {
//		log(this.name, oolite.compareVersion("1.79")+" "+player.ship.dataKey);//debug
		if( 0 < oolite.compareVersion("1.79") //if version is less than 1.79
 			//or the ship in hardships-menu.oolite-save loaded by scenario.plist
			|| player.ship.dataKey == "hardcobra3-player" ) { //to allow starting in hauler, etc.
			this.$HardMenu_ReplacePlayerShip2(this.$HardMenu_Name[0], 0); 
			this.$HardMenu_NewGameScreen();
		}
	}
	delete this.guiScreenChanged;
}

this.shipWillExitWitchspace = function() {//place some HardShip into the system
	if(this.ship === player.ship && !system.isInterstellarSpace) {
		//setup the ambush, less probable in safe governments
		if (Math.random() > system.government / 7 ) {//government:0-7 Anarchy-Corporate State
			//more pirate with techlevel and unsafety
			var tech = Math.random() * system.techLevel / 5;//same bonus to pirates and police
			var num = Math.ceil(tech + ( 7 - system.government) / 2);//number of pirate ships, 1-7
			var rnum = 1 + Math.floor(Math.random() * (num - 1));//about the half is hardpirate
			var radius = 10000 + Math.random() * 30000;
			system.addShips("hardpirate", rnum, player.ship.position, radius);
			if(num > rnum) system.addShips("pirate", num - rnum, player.ship.position, radius);
			if ( system.government > 0 ) {//no police in Anarchy
				//more police with techlevel and safety
				num = Math.ceil(tech + system.government / 3);///number of police ships, 1-5 
				rnum = Math.floor(1 + Math.random() * (num - 1));//about the half is hardpolice
				radius = 1000 + Math.random() * 29000; //closer to the player
				if(rnum > 0) system.addShips("hardpolice", rnum, player.ship.position, radius);
				if(num > rnum) system.addShips("police", num - rnum, player.ship.position, radius);
			}
		}
		this.$HardMenu_AddHardShipsToTheSystem();
	}
}

this.shipWillLaunchFromStation = function() {
	player.ship.hudHidden = false;
	this.$HardMenu_AddHardShipsToTheSystem();
	//Test Drive
	if(!this.$HardMenu_TestDriveTimer && missionVariables.HardShips_LoanAtStart
		&& missionVariables.HardShips_LoanAtStart<0) {
		missionVariables.HardShips_TestDriveTime = this.$HardMenu_TestDriveTime;//minutes
		this.$HardMenu_TestDriveTimer = new Timer(this, this.$HardMenu_TestDrive, 0, 60);
	}
}

this.$HardMenu_AddHardShipsToTheSystem = function() {
	if( system.isInterstellarSpace ) return;
	system.addShips("policedrone", 1, system.mainStation.position, 20000);//demo
	system.addShips("policeharddrone", 1, system.mainStation.position, 20000);//demo
	//setup a hardShip combat somewhere between the witchpoint and the planet
	var pos = player.ship.position;
	var place = Math.random() * 0.9; //here will be the ships
	var ships = system.addShipsToRoute("hardtrader", 1, place, "wp");
	//player.consoleMessage("addShips "+ships);
	//player.consoleMessage(pos.x+" "+pos.y+" "+pos.z);	
	if(ships) if(ships[0]) if(ships[0].position) pos = ships[0].position;
	//player.consoleMessage("pos "+pos);
	system.addShips("hardhunter", 1, Vector3D(pos.x, pos.y, pos.z), 10000);
	system.addShips("hardpirate", 3, pos);
	if ( system.government > 0 ) system.addShips("hardpolice", 1, pos); //no police in Anarchy		
	//add sun guards
	system.addShipsToRoute("hardpirate", 2, 0.9, "ws");
	system.addShipsToRoute("hardpirate", 2, 0.9, "ps");
	//add solo ships
	system.addShipsToRoute("hardtrader", 1, Math.random(), "wp");
	system.addShipsToRoute("hardtrader", 1, Math.random(), "ps");
	system.addShipsToRoute("hardhunter", 1, Math.random(), "ws");
	system.addShipsToRoute("hardpirate", 1, Math.random(), "wp");
	system.addShipsToRoute("hardpirate", 1, Math.random(), "ps");
	system.addShipsToRoute("hardpirate", 1, Math.random(), "ws");
	if ( system.government > 0 ) //no police in Anarchy
		system.addShipsToRoute("hardpolice", 1, Math.random(), "wp");
}

this.$HardMenu_TestDrive = function() {
	var t = missionVariables.HardShips_TestDriveTime;
	if(t > 0) {
		if(t == this.$HardMenu_TestDriveTime || t < 6)
			player.commsMessage(t+" minutes left from your test drive.",10);
		missionVariables.HardShips_TestDriveTime--;
	} else {//time out
		missionVariables.HardShips_TestDriveTime = 0;
		missionVariables.HardShips_LoanAtStart = 0;
		//player.ship.launch();
		player.consoleMessage("Thank you for the testing! Your game will be over in 10 seconds.",5);
		if(this.$HardMenu_TestDriveTimer) {
			this.$HardMenu_TestDriveTimer.stop();
			delete this.$HardMenu_TestDriveTimer;
		}
		this.$HardMenu_TestDriveTimerEnd = new Timer(this, this.$HardMenu_TestDriveEnd, 5, 0);
	}
}

this.$HardMenu_TestDriveEnd = function() {
	player.consoleMessage("You can begin new game and select a ship.",5);
	if(this.$HardMenu_TestDriveTimerEnd) {
		this.$HardMenu_TestDriveTimerEnd.stop();
		delete this.$HardMenu_TestDriveTimerEnd;
	}
	this.$HardMenu_TestDriveTimerEnd = new Timer(this, this.$HardMenu_TestDriveEnd2, 5, 0);
}

this.$HardMenu_TestDriveEnd2 = function() {
	if(this.$HardMenu_TestDriveTimerEnd) {
		this.$HardMenu_TestDriveTimerEnd.stop();
		delete this.$HardMenu_testDriveTimerEnd;
	}
	player.ship.launch();//needed to explode
	player.ship.explode();//Game Over
}

this.$HardMenu_ShipConfirmed = function(shipid) {
	player.ship.hudHidden = false;
	player.ship.fuel = this.$HardMenu_StartFuel;
	if(shipid == 5) {//HardRacer start with a missile to test
		player.ship.awardEquipment("EQ_MISSILE");
	}
	if(missionVariables.HardShips_LoanAtStart && missionVariables.HardShips_LoanAtStart<0 
	  || player.ship.dataKey == "hardescape-capsule-player")
		player.ship.fuel = 7;//test ship or ecape pod, needed to Injectors
	var credits = this.$HardMenu_StartCredits - player.ship.price; //less than 0 if test drive
	missionVariables.HardShips_LoanAtStart = credits;//trigger the test drive timer if negative
	player.credits = credits; //the game set it to 0 if negative
}

this.$HardMenu_ReplacePlayerShip = function(shipname) {
	this.$HardMenu_ReplacePlayerShip2(shipname, Math.floor(Math.random()*32767) ); //must give correct number to make other entityPersonalyit than 0
}

this.$HardMenu_ReplacePlayerShip2 = function(shipname, pers) {
//	player.consoleMessage(player.ship.name);//debug
	player.replaceShip(shipname, pers);
	player.replaceShip(shipname, pers);//bugfix for eqs with conditions scripts: need double replace to work!
	if(worldScripts["shipversion"]) {
		var shipVersion = worldScripts["shipversion"].$ShipVersion_Int(player.ship);
		if(player.ship.equipmentStatus("EQ_SHIP_VERSION_"+shipVersion) === "EQUIPMENT_UNAVAILABLE")
			player.ship.awardEquipment("EQ_SHIP_VERSION_"+shipVersion);
	}
	if(worldScripts["hardships"]) {
		if( player.ship.scriptInfo ) {
			var h = parseInt(player.ship.scriptInfo.hardarmour); //award Hard Armour equipment to show version
			if( h > 0 && player.ship.equipmentStatus("EQ_HARDARMOUR_III") == "EQUIPMENT_UNAVAILABLE"
				&& player.ship.equipmentStatus("EQ_HARDARMOUR_V") == "EQUIPMENT_UNAVAILABLE"
				&& player.ship.equipmentStatus("EQ_HARDARMOUR_X") == "EQUIPMENT_UNAVAILABLE" ) {
				var v = "III";
				if( h >= 10 ) v = "X";
				else if( h >= 5 ) v = "V";
				player.ship.awardEquipment("EQ_HARDARMOUR_"+v);
			}
		}
	}
//	player.consoleMessage(player.ship.name);//debug
}

this.$HardMenu_GetPlayerShipData = function() { //called from shipversion.js of Ship Version OXP also
	//detailed ship info old version, new can be found in rocketmenu.js of the RocketShips OXP
	player.ship.hudHidden = true;
	var equip="";
	var s=""; 
	s=player.ship.forwardWeapon;
	if( s!=null ) equip+="Forward "+s.name;
	s=player.ship.aftWeapon;
	if( s!=null ) equip+=", Aft "+s.name;
	s=player.ship.portWeapon;
	if( s!=null ) equip+="\nPort "+s.name;
	s=player.ship.starboardWeapon;
	if( s!=null ) equip+=", Starboard "+s.name;
	if(equip.length > 0) equip+="\n";
	else equip+="No Laser\n";
	var eqs = "";
	var n = "";
	var eq = player.ship.equipment;
	var i=-1;
	while(eq[++i]) {
		n = eq[i].name;
//		eqs += n + ", "; if( n.length == 0 && !skipped ) { //debug
		if( n.length > 0 ) eqs += n + ", ";
		else {	//skip noname eqs awarded by NumericHUD to avoid timeLimit error
			//bugfix for timeLimit caused by many noname eqs from NumericHUD on slow computer:
			//[script.javaScript.timeLimit] OperationCallback (OOJSEngineTimeManagement.m:221):
			//***** ERROR: Script "hardmenu" ran for 1.07 seconds and has been terminated.
			for( var j = i + 10; j < eq.length; j+=10 ) {
				if( eq[j].name.length != 0 ) {
					i = j - 10; //end of skip
					j = eq.length;
				}
			}
			while( i < eq.length && eq[i].name.length == 0 ) i++;
			i--;
		}
	}
	eqs = eqs.substr(0, eqs.length - 2); //cut last comma
	if( eqs.length > 0 ) equip+=eqs+"\n\n";
	else equip+="\n";//empty line before desc if no eqs
	var desc = "";
	var sh = player.ship.maxForwardShield;
	if( player.ship.dataKey.indexOf("escape-capsule-player") > -1 ) sh = 0;
	else if( worldScripts["shieldequalizercapacitors"] ) {
		if( player.ship.equipmentStatus("E//internal properties, should not touchQ_BIGSHCAP") == "EQUIPMENT_OK"
			&& player.ship.equipmentStatus("EQ_FORWARD_SHIELD_CAPACITOR") == "EQUIPMENT_OK" )
			sh = sh + "+256";
		else if( player.ship.equipmentStatus("EQ_FORWARD_SHIELD_CAPACITOR") == "EQUIPMENT_OK" )
			sh = sh + "+64";
	}
	if( player.ship.scriptInfo && player.ship.scriptInfo.buydesc )//show ship description if any
		desc="\""+player.ship.scriptInfo.buydesc+"\"\n\n";
	var psd = "";//player.ship.displayName+
	var hd = "";
	if(!player.ship.hasHyperspaceMotor ) hd = "   No Hyperdrive";
	psd += "Speed: "+(player.ship.maxSpeed)+" mLS  Thrust: "+player.ship.maxThrust+
		"  Pitch: "+Math.round(player.ship.maxPitch*100)/100+
		"  Roll: "+Math.round(player.ship.maxRoll*100)/100+
		"  Yaw: "+Math.round(player.ship.maxYaw*100)/100+hd+
//		"  Version: "+this.$shipVersion(player.ship)+
//		"  Service "+player.ship.serviceLevel+
		"\nCargo Space: "+player.ship.cargoSpaceCapacity;
	if( player.ship.scriptInfo && player.ship.scriptInfo.cargoext && parseInt(player.ship.scriptInfo.cargoext) > 0 )
		psd += "+"+parseInt(player.ship.scriptInfo.cargoext);
	var r = "";
	if( player.ship.scriptInfo && player.ship.scriptInfo.recharge && parseInt(player.ship.scriptInfo.recharge) > 0 )
		r = "  Recharge: "+parseInt(player.ship.scriptInfo.recharge);
	var sp = "";
	var sph = Math.round(player.ship.collisionRadius*player.ship.collisionRadius*Math.PI);
	if( sph < 1000000 ) sp = sph;
	else sp = Math.round(sph/100000)/10+"k";//show large sphere in km^2
	psd += "t  Mass: "+Math.max(Math.round(player.ship.mass/1000), 1)+ //min.1t
		"t  Size: "+Math.round(player.ship.boundingBox.x)+"*"+
		Math.round(player.ship.boundingBox.y)+"*"+Math.round(player.ship.boundingBox.z)+
		"m Radius: "+Math.round(player.ship.collisionRadius)+"m Sphere: "+sp+
		"m^2\nEnergy: "+player.ship.maxEnergy+r+"  Shield: "+sh+"  Max.Missile: "+player.ship.missileCapacity;
	if( player.ship.scriptInfo && player.ship.scriptInfo.hardarmour && parseInt(player.ship.scriptInfo.hardarmour) > 0 )
		psd += "\nHard Armour deflect "+parseInt(player.ship.scriptInfo.hardarmour)+" points from any damage";
	psd += "\n"+equip+desc+"Price: "+formatCredits(player.ship.price, false, true);
	return(psd);
}

this.$HardMenu_NewGameScreen = function() {
	player.ship.hudHidden = true;
	player.ship.removeEquipment("EQ_FUEL_INJECTION");
	player.ship.removeEquipment("EQ_FUEL_SCOOPS");
	player.ship.removeEquipment("EQ_WEAPON_MINING_LASER");
	var options = {
                "_0" : "HardShips",
		"_1" : "Classic: Cobra Mk III",
		"_2" : "Fast-track: Cobra Mk III with extra equipment",
		"_3" : "Medium: Cobra Mk I",
		"_4" : "Hard: Adder",
		"_5" : "Harder: Adder Broke",
		"_6" : "Hardest: Escaped Broke",
		"_7" : "Hauler: Beaten-up Python",
		"_8" : "Exotic Ships"
	};
	mission.runScreen({
		title: "New Game Selection" ,
		message: "Greetings Commander. You are about to start your new career of space flight, combat and trading starting from the space station orbiting the planet Lave. Before embarking you will need to select a starting ship.\n\n"+
			"HardShips covered by orange Hard Armour to partially deflect laser and other attacks at a cost of the lower acceleration and brake.\n\n"+
			"Costly HardShips are available for a test drive only: you will set back here in "+this.$HardMenu_TestDriveTime+" minutes. There are more choices below if you want the Classic start or some harder situations.\n\nAfter having made your choice, go to options and choose your name by saving the game.",
		choices: options,
		initialChoicesKey: "_"+this.$HardMenu_LastMainMenuItem,
		model: "[hard-cobra3]",
		spinModel: true,
		background: "start_choices_bg.png"
	},		
	function (choice)
	{
                if (choice === "_0") this.$HardMenu_Choice(0);
                else if (choice === "_1") this.$HardMenu_Choice(1);
                else if (choice === "_2") this.$HardMenu_Choice(2);
                else if (choice === "_3") this.$HardMenu_Choice(3);
		else if (choice === "_4") this.$HardMenu_Choice(4);
		else if (choice === "_5") this.$HardMenu_Choice(5);
		else if (choice === "_6") this.$HardMenu_Choice(6);
		else if (choice === "_7") this.$HardMenu_Choice(7);
		else if (choice === "_8") this.$HardMenu_Choice(8);
	});		
}

this.$HardMenu_Choice = function(select) {
	this.$HardMenu_LastMainMenuItem = select;
	player.ship.hudHidden = true;
        var shipnum = 0;
	switch(select) {
                case 0:
			this.$HardMenu_NewGameScreen2(0);
			break;
		case 1: //classic start
			this.$HardMenu_ReplacePlayerShip2("cobra3-player", 0); //always get ShipVersion 1.0
			while (player.ship.missiles.length < 3)
				player.ship.awardEquipment("EQ_MISSILE");
			player.credits = 100;
			player.ship.fuel = 100;
			var dname=player.ship.displayName;
			if( worldScripts["shipversion"] ) dname = worldScripts["shipversion"].$ShipVersion_PlayerShipName();
			var options = {
				"1_NO" : "Go Back",
				"2_YES" : "Confirm Choice"
			};
			mission.runScreen({
				title: "Classic Start" ,
				message: "Ship: "+dname+"\nSpeed: 0.35 lm\nCargo Space: 20 t\nBase Equipment: Pulse Laser, 3 Missiles\n\Fuel: 7.0 ly\nCredits: "+formatCredits(100, true, true)+
					"\n\n\"The most successful medium-size ship ever built and a versatile fighter/trader ship.\"",
				choices: options,
				model: "[cobra3-player]",
				background: "start_choices_bg.png"
			},
			function (choice) {
				if (choice === "1_NO") this.$HardMenu_NewGameScreen();
			});
			break;
		case 2: //easy start
			this.$HardMenu_ReplacePlayerShip2("cobra3-player", 0); //always get ShipVersion 1.0
			player.credits = 100;
			player.ship.fuel = 100;
			while (player.ship.missiles.length < 3)
				player.ship.awardEquipment("EQ_MISSILE");
			player.ship.awardEquipment("EQ_FUEL_INJECTION");
			player.ship.awardEquipment("EQ_FUEL_SCOOPS");
			player.ship.aftWeapon = "EQ_WEAPON_MINING_LASER";
			var dname=player.ship.displayName;
			if( worldScripts["shipversion"] ) dname = worldScripts["shipversion"].$ShipVersion_PlayerShipName();
			var options = {
				"1_NO" : "Go Back",
				"2_YES" : "Confirm Choice"
			};
			mission.runScreen({
				title: "Fast-track Start" ,
				message: "Ship: "+dname+"\nSpeed: 0.35 lm\nCargo Space: 20 t\nBase Equipment: Pulse Laser, Mining Laser, 3 Missiles,  Fuel Scoops, Witchspace Fuel Injectors\n\Fuel: 7.0 ly\nCredits: "+formatCredits(100, true, true)+"\n\n* Bounty Hunter: Collect bounties for pirate/fugitive craft destoyed. Capture/rescue escape pods for rewards.\n* Carrier Service: Deliver goods for some-one else and get paid. You can do parcel deliveries right from the start, but for carrier contracts you'll need a ship with larger cargo bays. Find contracts from the interfaces screen.\n* Miner: Blast the asteroids with your mining laser, scoop the fragments and sell the minerals. Aim for the sun to find asteroids.\n* Passenger Service: Carry passengers for profit. You'll need a passenger berth installed to do passenger contracts. Find contracts from the interfaces screen.\n* Trader: Buy low-priced commodities on one world and sell at a higher price on another.",
				choices: options,
				model: "[cobra3-player]",
				background: "start_choices_bg.png"
			},		
			function (choice) {
				if (choice === "1_NO") this.$HardMenu_NewGameScreen();
			});					
			break;
		case 3: //medium start
			this.$HardMenu_ReplacePlayerShip2("cobramk1-player", 0); //always get ShipVersion 1.0
			player.credits = 100;
			player.ship.fuel = 100;
			var dname=player.ship.displayName;
			if( worldScripts["shipversion"] ) dname = worldScripts["shipversion"].$ShipVersion_PlayerShipName();
			var options = {
				"1_NO" : "Go Back",
				"2_YES" : "Confirm Choice"
			};
			mission.runScreen({
				title: "Medium Start" ,
				message: "Ship: "+dname+"\nSpeed: 0.26 lm\nCargo Space: 10 t\nBase Equipment: Pulse Laser, 1 Missile\n\Fuel: 7.0 ly\nCash: "+formatCredits(100, true, true)+
					"\n\n\"The first truly effective solo fighter/trader ship, but now superceded by the Mk III.\"",
				choices: options,
				model: "[cobramk1-player]",
				background: "start_choices_bg.png"
			},
			function (choice) {
				if (choice === "1_NO") this.$HardMenu_NewGameScreen();
			});
			break;
		case 4: //hard start
			this.$HardMenu_ReplacePlayerShip2("adder-player", 0); //always get ShipVersion 1.0
			player.credits = 100;
			player.ship.fuel = 100;
			var dname=player.ship.displayName;
			if( worldScripts["shipversion"] ) dname = worldScripts["shipversion"].$ShipVersion_PlayerShipName();
			var options = {
				"1_NO" : "Go Back",
				"2_YES" : "Confirm Choice"
			};
			mission.runScreen({
				title: "Hard Start" ,
				message: "Ship: "+dname+"\nSpeed: 0.24 lm\nCargo Space: 2+3 t\nBase Equipment: Pulse Laser, 1 Missile, External Heat Shielding\n\Fuel: 7.0 ly\nCash: "+formatCredits(100, true, true)+
				"\n\n\"An agile and compact ship favored by couriers, customizers and professional racers.\"",
				choices: options,
				model: "[adder-player]",
				background: "start_choices_bg.png"
			},
			function (choice) {
				if (choice === "1_NO") this.$HardMenu_NewGameScreen();
			});
			break;
		case 5: //harder start
			this.$HardMenu_ReplacePlayerShip2("adder-player", 0); //always get ShipVersion 1.0
			var dname=player.ship.displayName;
			if( worldScripts["shipversion"] ) dname = worldScripts["shipversion"].$ShipVersion_PlayerShipName();
			player.credits = 0;
			player.ship.fuel = 0;
			player.ship.removeEquipment("EQ_HEAT_SHIELD");
			player.ship.removeEquipment("EQ_MISSILE");
			var options = {
				"1_NO" : "Go Back",
				"2_YES" : "Confirm Choice"
			};
			mission.runScreen({
				title: "Harder Start" ,
				message: "Ship: "+dname+"\nSpeed: 0.24 lm\nCargo Space: 2+3 t\nBase Equipment: Pulse Laser\n\Fuel: 0.0 ly\nCash: "+formatCredits(0, true, true)+
					"\n\n\"An agile and compact ship favored by couriers, customizers and professional racers, although you must find a way to earn credits for fuel, equipment and upgrades.\"",
				choices: options,
				model: "[adder-player]",
				background: "start_choices_bg.png"
			},		
			function (choice) {
				if (choice === "1_NO") {
					player.credits = 100;
					player.ship.fuel = 100;
					player.ship.awardEquipment("EQ_MISSILE");
					player.ship.awardEquipment("EQ_HEAT_SHIELD");
					this.$HardMenu_NewGameScreen();
				}
			});
			break;
		case 6: //hardest
			player.replaceShip("hardescape-capsule-player", 0);
			player.credits = 0;
			player.ship.fuel = 0;
			player.ship.removeEquipment("EQ_HEAT_SHIELD");
			player.ship.removeEquipment("EQ_MISSILE");
			var dname=player.ship.displayName;
			var options = {
				"1_NO" : "Go Back",
				"2_YES" : "Confirm Choice"
			};
			mission.runScreen({
				title: "Hard Pod",
				message: this.$HardMenu_GetPlayerShipData(0),
				choices: options,
				model: "[hardescape-capsule-player]",
				background: "start_choices_bg.png"
			},
			function (choice) {
				if (choice === "1_NO") {
					player.credits = 100;
					player.ship.fuel = 100;
					player.ship.awardEquipment("EQ_MISSILE");
					player.ship.awardEquipment("EQ_HEAT_SHIELD");
					this.$HardMenu_NewGameScreen();
				}
				player.ship.hudHidden = false;
                                player.ship.fuel = 7;
			});
			break;
		case 7: //hauler start
			player.replaceShip("python-player", 0);
			this.$HardMenu_serviceLevel = player.ship.serviceLevel;
			player.ship.serviceLevel = 75;
			var options = {
				"1_YES" : "Confirm Choice",
				"2_NO" : "Go Back"
			};
			mission.runScreen({
				title: "Harder Start" ,
				message: "Ship: Python\nSpeed: 0.20 lm\nCargo Space: 100 t\nBase Equipment: Pulse Laser\n\Fuel: 7.0 ly\nCash: "+formatCredits(100, true, true)+"\n\n\"An ageing design that’s still popular with commanders needing a simple robust freighter. She's in a bad shape though, be ready for malfunctions until you can afford a maintenance overhaul.\"",
				choices: options,
				model: "[python-player]",
				background: "start_choices_bg.png"
			},		
			function (choice) {
				if (choice === "2_NO") {
					player.ship.serviceLevel = this.$HardMenu_serviceLevel;
					this.$HardMenu_NewGameScreen();
				}
			});	
			break;
                case 8:
			this.$HardMenu_NewGameScreen2(10);
			break;
	}
}

this.$HardMenu_NewGameScreen2 = function(lastship) {
	player.ship.hudHidden = true;
	if( lastship < 0 ) lastship = 0;
	missionVariables.targetAutolock = null;//bugfix for ships equipped with Autolock in shipyard.plist
	if( lastship == 0 ) this.$HardMenu_ReplacePlayerShip2(this.$HardMenu_Name[lastship], 0); //Cobra III always get ShipVersion 1.0
	else this.$HardMenu_ReplacePlayerShip(this.$HardMenu_Name[lastship]);
	if(player.ship.equipmentStatus("EQ_HEAT_SHIELD") != "EQUIPMENT_UNAVAILABLE")
		player.ship.removeEquipment("EQ_HEAT_SHIELD");
	while(player.ship.equipmentStatus("EQ_MISSILE") != "EQUIPMENT_UNAVAILABLE")
		player.ship.removeEquipment("EQ_MISSILE");
	var shipname = $HardMenu_Name[lastship];
	var dname=player.ship.displayName;
//	log("hardmenu",shipname+" "+dname);
	if( worldScripts["shipversion"] ) dname = worldScripts["shipversion"].$ShipVersion_PlayerShipName();	
	if( lastship < 10 ) {
		var options = {
			"_" : "Confirm Choice",
			"_0" : "Hard Cobra Mk III",
			"_1" : "Hard Cobra Mk I",
			"_2" : "Hard Adder",
			"_3" : "Hard Moray",
			"_4" : "Test: Hard Anaconda",
			"_5" : "Test: Hard Asp",
			"_6" : "Test: Hard Boa",
			"_7" : "Test: Hard Boa Mk2",
			"_8" : "Test: Har-de-Lance",
			"_9" : "Test: Hard Python",
			"X" : "Go Back"
		};		
//player.consoleMessage(this.$HardMenu_Name[lastship]+"["+player.ship.dataKey.substr(0,player.ship.dataKey.length-7)+"-model]");
		mission.runScreen({
			title: dname,
			message: this.$HardMenu_GetPlayerShipData(lastship),
			choices: options,
			initialChoicesKey: "_"+(lastship),
			model: "["+player.ship.dataKey+"]",//.substr(0,player.ship.dataKey.length-7)+"]",
			background: "start_choices_bg.png"
		},
		function (choice)
		{
			player.ship.hudHidden = true;
			if (choice == "_0") this.$HardMenu_NewGameScreen2(0);
			else if (choice == "_1") this.$HardMenu_NewGameScreen2(1);
			else if (choice == "_2") this.$HardMenu_NewGameScreen2(2);
			else if (choice == "_3") this.$HardMenu_NewGameScreen2(3);
			else if (choice == "_4") this.$HardMenu_NewGameScreen2(4);
			else if (choice == "_5") this.$HardMenu_NewGameScreen2(5);
			else if (choice == "_6") this.$HardMenu_NewGameScreen2(6);
			else if (choice == "_7") this.$HardMenu_NewGameScreen2(7);
			else if (choice == "_8") this.$HardMenu_NewGameScreen2(8);
			else if (choice == "_9") this.$HardMenu_NewGameScreen2(9);
			else if (choice == "X") this.$HardMenu_NewGameScreen();
			this.$HardMenu_ShipConfirmed(lastship);
		});
	} else {
		var options = {
			"_A" : "Confirm Choice",
			"_B" : "Gecko",
			"_C" : "Krait",
			"_D" : "Mamba",
			"_E" : "Sidewinder",
			"_F" : "Shuttle",
			"_G" : "Transporter",
			"_H" : "Worm",
			"_I" : "Test: Viper",
			"_J" : "Test: Viper Interceptor",
			"_K" : "Test: Constrictor",
			"_L" : "Test: Thargoid",
			"_M" : "Test: Tharglet",
			"X" : "Go Back"
		};		
//player.consoleMessage(this.$HardMenu_Name[lastship]+"["+player.ship.dataKey.substr(0,player.ship.dataKey.length-7)+"-model]");
		var init="B";
		switch(lastship) {
                	case 10: init="B"; break;
                	case 11: init="C"; break;
			case 12: init="D"; break;
                	case 13: init="E"; break;
                	case 14: init="F"; break;
                	case 15: init="G"; break;
                	case 16: init="H"; break;
                	case 17: init="I"; break;
                	case 18: init="J"; break;
                	case 19: init="K"; break;
                	case 20: init="L"; break;
                	case 21: init="M"; break;
		}
		mission.runScreen({
			title: dname,
			message: this.$HardMenu_GetPlayerShipData(lastship),
			choices: options,
			initialChoicesKey: "_"+init,
			model: "["+player.ship.dataKey+"]",//.substr(0,player.ship.dataKey.length-7)+"]",
			background: "start_choices_bg.png"
		},
		function (choice)
		{
			player.ship.hudHidden = true;
			if (choice == "_B") this.$HardMenu_NewGameScreen2(10);
			else if (choice == "_C") this.$HardMenu_NewGameScreen2(11);
			else if (choice == "_D") this.$HardMenu_NewGameScreen2(12);
			else if (choice == "_E") this.$HardMenu_NewGameScreen2(13);
			else if (choice == "_F") this.$HardMenu_NewGameScreen2(14);
			else if (choice == "_G") this.$HardMenu_NewGameScreen2(15);
			else if (choice == "_H") this.$HardMenu_NewGameScreen2(16);
			else if (choice == "_I") this.$HardMenu_NewGameScreen2(17);
			else if (choice == "_J") this.$HardMenu_NewGameScreen2(18);
			else if (choice == "_K") this.$HardMenu_NewGameScreen2(19);
			else if (choice == "_L") this.$HardMenu_NewGameScreen2(20);
			else if (choice == "_M") this.$HardMenu_NewGameScreen2(21);
			else if (choice == "X") this.$HardMenu_NewGameScreen();
			this.$HardMenu_ShipConfirmed(lastship);
		});		
	}
}
