"use strict";
this.name        = "hardnose";
this.author      = "Norby";
this.copyright   = "2013 Norbert Nagy";
this.licence     = "CC BY-NC-SA 3.0";
this.description = "Hard Nose check to fit in the Max with the base Hard Armour.";
this.version     = "1.0";

this.allowAwardEquipment = function(eqKey, ship, context)
{
	if( ship.mass < 30000 ) return false; //small ship can not get nose
	if( eqKey==="EQ_HARDNOSE" && (!ship.scriptInfo || !ship.scriptInfo.hardarmour) )
		return true; //can get nose a ship without Hard Armour also
	if( eqKey==="EQ_HARDNOSE" && ship.scriptInfo && ship.scriptInfo.hardarmour //awardable only if fit in Max
		&& parseInt(ship.scriptInfo.hardarmour) + 5 <= worldScripts["hardships"].$HardShips_MaxHardArmour )
		return true;

	if( ship.mass < 130000 ) return false; //only a large ship can get the following things
	if( (eqKey==="EQ_VERYHARDNOSE" || eqKey==="EQ_VERYVERYHARDNOSE")
		&& (!ship.scriptInfo || !ship.scriptInfo.hardarmour) )
		return true; //can get nose a ship without Hard Armour also
	if( eqKey==="EQ_VERYHARDNOSE" && ship.scriptInfo && ship.scriptInfo.hardarmour
		&& parseInt(ship.scriptInfo.hardarmour) + 10 <= worldScripts["hardships"].$HardShips_MaxHardArmour )
		return true;
	if( eqKey==="EQ_VERYVERYHARDNOSE" && ship.scriptInfo && ship.scriptInfo.hardarmour
		&& parseInt(ship.scriptInfo.hardarmour) + 15 <= worldScripts["hardships"].$HardShips_MaxHardArmour )
		return true;
	return false;
}
